/* $Id: error.h,v 1.5 2005/08/02 19:35:49 jonathan Exp $
 * Jonathan Ledlie, Harvard University.
 * Copyright 2005.  All rights reserved.
 */

#ifndef ERROR_H
#define ERROR_H

#include <stdio.h>
#include <stdlib.h>

// Comment out to remove all debugging paths
#define DEBUG 1

#ifdef DEBUG
extern bool debug;
#define DEBUG_P(c) if (debug) printf c;
#define IF_DEBUG(c)   if (debug) c;
#else
#define DEBUG_P(c) 
#define IF_DEBUG(c)
#endif

#define ASSERT(c) { \
  if (!(c)) { \
    fprintf (stderr, \
	     "ASSERTION FAILURE: %s:%d\n", __FILE__, __LINE__); \
    fprintf (stderr, "\tfailed condition: %s\n", #c); \
    exit (-1); \
  } \
}

//#define ASSERT(c) 

#endif
